' O2ListView.inc
' contains all the O2 macros , types,  functions and constants needed by a ListView control
'  requires O2Common.inc be included prior to this file
' updated  Jan 14 2019

'#Lookahead


'=============================
 'Load the common controls library.. for ListView
Sub  InitCommonCont_LV
        INITCOMMONCONTROLSEXt icce
         icce.dwSize = sizeof(INITCOMMONCONTROLSEXt)
         icce.dwICC = 0xffff
         InitCommonControlsEx(&icce)
End Sub


  type NMHDR
  sys     hwndFrom
  sys     idFrom  'uint ptr
  uint     code 
  end type


' Type definitions

' by Roland
type LVCOLUMN 
  uint  mask 
  int   fmt 
  int   cx 
  char* pszText 
  int   cchTextMax 
  int   iSubItem 
  int   iImage
  int   iOrder
  int   cxMin
  int   cxDefault
  int   cxIdeal  
end type 
typedef LVCOLUMN LV_COLUMN

'  

' by Roland
type LVITEM  
  uint   mask 
  int    iItem 
  int    iSubItem 
  uint   state 
  uint   stateMask 
  char*  pszText 
  int    cchTextMax 
  int    iImage       // index of the list view item's icon 
  sys    lParam       // 32-bit value to associate with item 
  int    iIndent
  int    iGroupId
  uint   cColumns
  'uint   *puColumns
  'int    *piColFmt
  'int    iGroup
end type


typedef     LVITEM    LV_ITEM

' by Roland
type NMLISTVIEW
  NMHDR  hdr
  int    iItem
  int    iSubItem
  UINT   uNewState
  UINT   uOldState
  UINT   uChanged
  POINT  ptAction
  sys    lParam
end type

typedef NMLISTVIEW    NM_LISTVIEW

' by Roland
type NMCUSTOMDRAW
  NMHDR     hdr
  DWORD     dwDrawStage
  sys       hdc
  RECT      rc
  sys       dwItemSpec 'DWORD_PTR 
  UINT      uItemState
  sys       lItemlParam
end type
 

' by Roland
type NMLVCUSTOMDRAW
  NMCUSTOMDRAW nmcd
  int          clrText     'COLORREF
  int          clrTextBk   'COLORREF
  int          iSubItem
  DWORD        dwItemType
  int          clrFace     'COLORREF
  int          iIconEffect
  int          iIconPhase
  int          iPartId
  int          iStateId
  RECT         rcText
  UINT         uAlign
end type
 


' ========================================================================================
' Changes the state of an item in a list-view control.
' ========================================================================================
SUB ListView_SetItemState (BYVAL hwndLV AS sys, BYVAL i AS LONG, BYVAL dwState AS sys, BYVAL mask AS sys)
   LOCAL lvi AS LVITEM
   lvi.stateMask = mask
   lvi.state = dwState
   SendMessage hwndLV, LVM_SETITEMSTATE, i, VARPTR(lvi)
END SUB



' same as in Roland except Roland did not have ListView_SetColumnWidth
macro ListView_InsertColumn(hwnd,iCol,pcol) (SendMessage(hwnd, LVM_INSERTCOLUMN, iCol, pcol))
macro ListView_SetColumnWidth(hwnd,iCol,cx) (SendMessage(hwnd, LVM_SETCOLUMNWIDTH, iCol, cx))
macro ListView_InsertItem(hwnd,pitem) (SendMessage(hwnd, LVM_INSERTITEM,0, pitem))
macro ListView_SetItem(hwnd,pitem) (SendMessage(hwnd, LVM_SETITEM,0, pitem))




' by Roland
'==========================================
sub ListView_Insert_Column(sys hwnd, Long id, col, string Expr, int width, int fmt)
   LV_COLUMN lvc
   lvc.mask = LVCF_FMT OR LVCF_WIDTH OR LVCF_TEXT OR LVCF_SUBITEM
   lvc.fmt = fmt
   lvc.pszText = Expr   
   lvc.cx = width
   ListView_InsertColumn(GetDlgItem(hwnd, id), col-1, &lvc)
End Sub
 

'==========================================
'  For inserting into the ListView first column = 0
Sub ListView_Insert_FirstColumn(sys hwnd, Long id, string Expr, int width, int fmt)
   LV_COLUMN lvc
   lvc.mask =LVCF_WIDTH  or  LVCF_ORDER
   lvc.fmt = fmt
   lvc.pszText = Expr   
   lvc.cx = width
   ListView_InsertColumn(GetDlgItem(hwnd, id), 0, &lvc)
End Sub



' by Roland
'================================================
Sub ListView_Insert_Item(sys hwnd, Long id, row, image, string Expr)
   LV_ITEM lvi
   lvi.stateMask   = LVIS_FOCUSED
   lvi.mask = LVIF_TEXT 
   lvi.pszText = Expr
   lvi.iItem = row
   ListView_InsertItem(GetDlgItem(hwnd,id), &lvi)
End Sub 
 

' by Roland
'=========================================
Sub ListView_Set_Text(sys hwnd, Long id, row, col, string Expr)
   LV_ITEM lvi
   if col=1 then
     lvi.mask = LVIF_TEXT or LVIF_STATE or lVIF_PARAM
   else
     lvi.mask = LVIF_TEXT or LVIF_STATE
   end if  
   lvi.pszText = Expr
   lvi.iItem = row-1
   lvi.iSubItem = col-1
   ListView_SetItem(GetDlgItem(hwnd,id), &lvi)
End Sub
 

' by Roland
'===============================
'  Get the Maximum of 2 numbers
Function MAX(Long  num1, num2) as Long
  if num1 > num2 then
       return num1
  end if
  return num2
End Function


 ' by Roland
'===========================
'  Get the Minimum of 2 numbers
Function MIN(Long num1, num2) as Long
  if num1 < num2 then 
      return num1
 end if
  return num2
End Function
 

' ========================================================================================
' Gets information about the rectangle that surrounds a subitem in a list-view control.
' This function is intended to be used only on list-view controls that use the LVS_REPORT style.
FUNCTION ListView_GetSubItemRect (BYVAL hwndLV AS sys , BYVAL iItem AS LONG, _
        BYVAL iSubItem AS LONG, BYVAL nCode AS LONG, BYREF prc AS RECT) AS LONG
   IF VARPTR(prc) THEN
      prc.Top = iSubItem
      prc.Left = nCode
   END IF
   FUNCTION = SendMessage(hwndLV,  LVM_GETSUBITEMRECT, iItem, VARPTR(prc))
END FUNCTION



' ========================================================================================
' Gets the text of a list-view item or subitem.
'  DO NOT use as it does NOT work   Jan 14 2019
SUB ListView_GetItemTextA (BYVAL hwndLV AS sys, BYVAL i AS LONG, BYVAL iSubItem AS LONG,  _
             BYREF char  pszText, BYVAL cchTextMax AS LONG)
   LOCAL lvi AS LVITEM
  
  lvi.mask = LVIF_TEXT
   lvi.iSubItem = iSubItem
   lvi.cchTextMax = cchTextMax
   lvi.pszText =       VARPTR(pszText)
   SendMessage  hwndLV,  LVM_GETITEMTEXTA, i,      VARPTR(lvi)
END SUB




' ========================================================================================
' Determines if an item in a list-view control is selected. This should be used only for
' list-view controls that have the LVS_EX_CHECKBOXES style.
' ========================================================================================
FUNCTION ListView_GetCheckState (BYVAL hwndLV AS sys, BYVAL i AS LONG) AS sys
   LOCAL nCheck AS LONG
   nCheck = SendMessage(hwndLV, LVM_GETITEMSTATE, i, LVIS_STATEIMAGEMASK)
   FUNCTION = BIT(nCheck, 12) - 1
END FUNCTION


' ========================================================================================
' Gets the width of a column in report or list view.
' ========================================================================================
FUNCTION ListView_GetColumnWidth (BYVAL hwndLV AS sys, iCol AS LONG) AS LONG
   FUNCTION = SendMessage(hwndLV, LVM_GETCOLUMNWIDTH, iCol, 0)
END FUNCTION


' ========================================================================================
' Gets the position of a list-view item.
' ========================================================================================
FUNCTION ListView_GetItemPosition (BYVAL hwndLV AS sys, BYVAL i AS LONG, BYREF ppt AS POINT) AS LONG
   FUNCTION = SendMessage(hwndLV, LVM_GETITEMPOSITION, i, VARPTR(ppt))
END FUNCTION


